

//  !hpf$ processors p(3, 2)
//
//  !hpf$ template t(30, 30)
//  !hpf$ distribute t(block, cyclic(10)) onto p
//
//  integer a(2, 3)
//  !hpf$ align a(i, j) with t(3 + 3 * i, 5 * j)
//
//  integer b(2, 4)
//  !hpf$ align b(*, j) with t(*, 25 - 2 * j)
//
//  integer v(6)
//  !hpf$ align v(j) with t(j, *)
//
//  integer pad(2)
//  !hpf$ align pad(j) with t(3, 27 + j)
//
//  integer shape(2), order(2)
//
//  integer i
//
//  do i = 1, 6
//    v(i) = i
//  enddo
//
//  pad(1) = 0
//  pad(2) = 0
//
//  shape(1) = 2
//  shape(2) = 3
//
//  a = reshape(v, shape)
//
//  print *, 'a...'
//  do i = 1, 2
//    print "(10i4)", a(i, : )
//  enddo
//
//  shape(1) = 2
//  shape(2) = 4
//
//  order(1) = 2
//  order(2) = 1
//
//  b = reshape(v, shape, pad, order)
//
//  print *, 'b...'
//  do i = 1, 2
//    print "(10i4)", b(i, : )
//  enddo
//end


#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 p(3, 2) ;

  BlockRange t1(30, p.dim(0)) ;
  //BlockRange t2(30, CyclicRange(3, p.dim(1))) ;
  BlockCyclicRange t2(30, p.dim(1), 10) ;

  Range x = t1.subrng(2, 5, 3) ;
  Range y = t2.subrng(3, 4, 5) ;

  Array2<int> a(x, y, p) ;

  Range i(2) ;
  Range j = t2.subrng(4, 22, -2) ;

  Array2<int> b(i, j, p) ;

  Range k = t1.subrng(6, 0) ;

  Array1<int> v(k, p) ;

  Range l = t2.subrng(2, 27) ;
  Group q(p / t1(2)) ;

  Array1<int> pad(l, p) ;
  
  ON(p) {
    Index i(k) ;
    OVERALL(i) {
      v(i) = i + 1 ;
    } ALLOVER(i) ;
  } NO(p) ;

  ON(q) {
    Index j(l) ;
    OVERALL(j) {
      pad(j) = 0 ;
    } ALLOVER(j) ;
  } NO(q) ;

  reshape(a, v) ;

  gprintf("a...\n") ;
  aprintf("%4d%*N", a, y.size()) ;

  Section2<int> dst(j, i, p, b.jmp(1), b.jmp(0), b.dat()) ;
                                                      // transpose section
  reshape(dst, v, pad) ;

  gprintf("b...\n") ;
  aprintf("%4d%*N", b, j.size()) ;

  AdlibFinalize() ;
}


